﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace ASPCallbackExample.Web
{
    public partial class CallbackControl : Page, ICallbackEventHandler
    {
        private string _jsonResult; 

        protected void Page_Load(object sender, EventArgs e)
        {
            var scriptManager = Page.ClientScript;
            var reference = scriptManager
                .GetCallbackEventReference(
                this, "arg", "GetContactInfoCompleted", "");
            var script = string.Format
                ("function GetContactInfoAsync(arg, context) {{{0};}}", 
                reference);
            scriptManager.RegisterClientScriptBlock(
                GetType(), "GetContactInfoAsync", script, true);
        }

        public void RaiseCallbackEvent(string eventArgument)
        {
            int id;
            if (int.TryParse(eventArgument, out id))
            {
                var contact = new Contact
                                    {
                                        Id = id, 
                                        FirstName = "Jeremy", 
                                        LastName = "Likness"
                                    };
                var jss = new JavaScriptSerializer();
                var sb = new StringBuilder();
                jss.Serialize(contact, sb);
                _jsonResult = sb.ToString();
            }
        }

        public string GetCallbackResult()
        {
            return _jsonResult;
        }
    }
}