﻿using System.Windows.Browser;
using System.Json;

namespace ASPCallbackExample
{
    public partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();
            Setup();
        }

        private void Setup()
        {
            if (!HtmlPage.IsEnabled) return;

            HtmlPage.RegisterScriptableObject(GetType().Name, this);

            var pluginName = HtmlPage.Plugin.Id;
            HtmlPage.Window.Eval(string.Format(
                @"window.PassContactToSilverlight = function (contact) {{
            var slApp = document.getElementById('{0}');
            var result = slApp.Content.{1}.OnContactSet(contact);            
        }}",
                pluginName, GetType().Name)
                );
        }

        [ScriptableMember]
        public void OnContactSet(string contact)
        {
            var json = JsonValue.Parse(contact);
            FirstName.Text = json["FirstName"];
            LastName.Text = json["LastName"];
        }
    }
}
