﻿using System.Windows;

namespace ApplicationLifecycleDemo
{
    public abstract class BaseAppService : IApplicationService, IApplicationLifetimeAware 
    {
        private WebServiceTest _test = new WebServiceTest();

        protected BaseAppService()
        {
            SimpleLogger.Log(GetType().FullName, "Constructor()");
            _test.Run();
        }

        public void StartService(ApplicationServiceContext context)
        {
            SimpleLogger.Log(GetType().FullName, "StartService()");
            _test.Run();
        }

        public void StopService()
        {
            SimpleLogger.Log(GetType().FullName, "StopService()");
            _test.Run();
        }

        public void Starting()
        {
            SimpleLogger.Log(GetType().FullName, "Starting()");
            _test.Run();
        }

        public void Started()
        {
            SimpleLogger.Log(GetType().FullName, "Started()");
            _test.Run();
        }

        public void Exiting()
        {
            SimpleLogger.Log(GetType().FullName, "Exiting()");
            _test.Run();
        }

        public void Exited()
        {
            SimpleLogger.Log(GetType().FullName, "Exited()");
            _test.Run();
        }
    }

    public class AppServiceOne : BaseAppService
    {        
    }

    public class AppServiceTwo : BaseAppService
    {        
    }    
}