﻿using System;
using System.Diagnostics;
using System.Net;

namespace ApplicationLifecycleDemo
{
    /// <summary>
    ///     Tests going out and hitting a web interface 
    /// </summary>
    public class WebServiceTest
    {
        private readonly Uri _uri = new Uri("http://feeds.feedburner.com/csharperimage/", UriKind.Absolute);

        public void Run()
        {
            var wc = new WebClient();
            wc.DownloadStringCompleted += _WcDownloadStringCompleted;
            Debug.WriteLine("Initiating web request to {0}", _uri);
            wc.DownloadStringAsync(_uri);
        }

        static void _WcDownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error != null)
            {
                Debug.WriteLine("WebRequest terminated with error: {0}", e.Error.Message);
            }
            else
            {
                Debug.WriteLine("Webrequest completed.");
            }
        }
    }
}