﻿using System.Windows;
using System.Windows.Controls;

namespace BehaviorsAndTriggers
{
    public partial class MainPage
    {
        public static readonly DependencyProperty TextOneProperty =
            DependencyProperty.Register("TextOne", 
            typeof (string), typeof (MainPage),
            new PropertyMetadata(default(string)));

        public string TextOne
        {
            get { return (string) GetValue(TextOneProperty); }
            set { SetValue(TextOneProperty, value); }
        }

        public static readonly DependencyProperty TextTwoProperty =
            DependencyProperty.Register("TextTwo", typeof (string), typeof (MainPage),
                                        new PropertyMetadata(default(string)));

        public string TextTwo
        {
            get { return (string) GetValue(TextTwoProperty); }
            set { SetValue(TextTwoProperty, value); }
        }

        public MainPage()
        {
            InitializeComponent();
            Loaded += MainPage_Loaded;
        }

        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            DataContext = this;
        }        
    }
}