﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Interactivity;
using System.Windows.Media;
using System.Windows.Media.Imaging;

namespace BehaviorsAndTriggers
{
    public class SnapshotTrigger : TriggerAction<UIElement>
    {
        protected override void Invoke(object parameter)
        {
            var bitmap = new WriteableBitmap(AssociatedObject, 
                new TranslateTransform());
            bitmap.Invalidate();
            var image = new Image
                            {
                                Source = bitmap, 
                                Width = bitmap.PixelWidth, 
                                Height = bitmap.PixelHeight,
                                IsHitTestVisible = false
                            };
            var scaleTransform = new ScaleTransform
                                        {
                                            ScaleX = 1.5, 
                                            ScaleY = 1.5
                                        };
            image.RenderTransform = scaleTransform;
            ((Grid)VisualTreeHelper.GetParent(AssociatedObject)).Children.Add(image);
        }
    }
}