﻿using System;
using System.Windows;
using System.Windows.Input;

namespace DataBindingExamples
{
    public class ShowCountryCommand : ICommand 
    {
        public bool CanExecute(object parameter)
        {
            var country = parameter as Country;
            return country != null;
        }

        public void Execute(object parameter)
        {
            MessageBox.Show(((Country) parameter).Name);
        }

        public void RaiseCanExecuteChanged()
        {
            var handler = CanExecuteChanged;
            if (handler != null)
            {
                handler(this, EventArgs.Empty);
            }
        }

        public event EventHandler CanExecuteChanged;
    }
}