﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Media;

namespace DependencyProperties
{
    public class ColorConverter : IValueConverter 
    {
        public object Convert(object value, 
            Type targetType, object parameter, 
            CultureInfo culture)
        {
            if (value == null || 
                string.IsNullOrEmpty(value.ToString()))
                return new SolidColorBrush(Colors.White);
            var propertyInfo = typeof (Colors).GetProperty(value.ToString());
            if (propertyInfo != null)
            {
                return new SolidColorBrush((Color) 
                    propertyInfo
                    .GetGetMethod()
                    .Invoke(null, new object[] {}));
            }
            return new SolidColorBrush(Colors.Black);
        }

        public object ConvertBack(object value, 
            Type targetType, object parameter, 
            CultureInfo culture)
        {
            return value;
        }
    }
}