﻿using System.Collections.Generic;
using System.ComponentModel;
using System.Json;

namespace DynamicDataExample
{
    public class CustomTypeViewModel : BaseViewModel
    {
        public CustomTypeViewModel()
        {
            if (DesignerProperties.IsInDesignTool)
            {
                return;
            }

            var jsonArray = JsonHelper.ParseAndLoad();

            if (jsonArray == null) return;

            // grab the first to use as a template
            var template = jsonArray[0] as JsonObject;

            if (template == null) return;

            // this will extract the properties and infer the types 
            var jsonHelper = new JsonHelper(template);

            foreach (var item in jsonArray)
            {
                var customType = new CustomType();
                customType.SetPropertyValue("Age", 37);

                // this will set the custom values
                jsonHelper.MapJsonObject(customType.SetPropertyValue, item);
                DataList.Add(customType);
            }            
        }
    }
}