﻿using System.ComponentModel;
using System.Json;
using System.Linq;

namespace DynamicDataExample
{
    public class DynamicTypeViewModel : BaseViewModel
    {
        public DynamicTypeViewModel()
        {
            if (DesignerProperties.IsInDesignTool)
            {
                return;
            }

            var jsonArray = JsonHelper.ParseAndLoad();

            if (jsonArray == null) return;

            // grab the first to use as a template
            var template = jsonArray[0] as JsonObject;

            if (template == null) return;

            // this will extract the properties and infer the types 
            var dynamicTypeHelper = new DynamicTypeHelper(
                "JsonType", template);

            foreach (var item in jsonArray.OfType<JsonObject>())
            {
                DataList.Add(dynamicTypeHelper.Generate(item));
            }
        }
    }
}