﻿namespace FluentValidation
{
    public class ContactData : BaseEntity
    {
        private readonly IValidationHelper _validation;
 
        public ContactData()
        {
            _validation = this.WithValidations()
                .ValidateThat<IsRequired>("Name")
                .ValidateThat<IsRequired>("Age")
                .AndThat<IsIntegerInRange>("Age", 1, 109)
                .AndThat<IsEmail>("Email");            
        }

        private string _name; 

        public string Name
        {
            get { return _name; }
            set 
            { 
                _name = value;
                RaisePropertyChange("Name");
            }
        }

        private string _age;

        public string Age
        {
            get { return _age; }
            set
            {
                _age = value;
                RaisePropertyChange("Age");
            }
        }

        private string _email; 

        public string Email
        {
            get { return _email; }
            set 
            { 
                _email = value;
                RaisePropertyChange("Email");
            }
        }
    }
}