﻿using System.Text.RegularExpressions;

namespace FluentValidation
{
    public class IsEmail : IValidation
    {
        public bool Validate(string value)
        {            
            return 
                string.IsNullOrEmpty(value) ||
                Regex.IsMatch(
                value,
                @"^[A-Z0-9._%-]+@[A-Z0-9.-]+\.[A-Z]{2,4}$",
                RegexOptions.IgnoreCase);
        }

        public string ValidationMessage
        {
            get 
            { 
                return "Field must be a valid e-mail address."; 
            }
        }
    }
}