﻿using System;

namespace FluentValidation
{
    public static class ValidationExtensions
    {
        public static IValidationHelper
            WithValidations<T>(this T instance) 
            where T: BaseEntity
        {
        return new ValidationHelper<T>(instance);   
        }      
       
        public static IValidationHelper
            ValidateThat<TValidator>(
                this IValidationHelper helper, 
                string propertyName,
                params object[] parms)
                    where TValidator: IValidation
        {
            var validator = (TValidator)Activator.CreateInstance(
                typeof (TValidator),
                parms);
            helper.RegisterValidation(propertyName, validator);
            return helper;
        }

        public static IValidationHelper
            AndThat<TValidator>(
                this IValidationHelper helper,
                string propertyName,
                params object[] parms)
            where TValidator : IValidation
        {
            return helper.ValidateThat<TValidator>(
                propertyName,
                parms);
        }
    }
}