﻿using System.Collections.ObjectModel;
using System.ComponentModel.DataAnnotations;
using Jounce.Core.Model;

namespace IsolatedStorageExample.Model
{
    public class Category : BaseNotify
    {
        public Category()
        {
            Notes = new ObservableCollection<Note>();
        }

        private string _name;
        public string Name
        {
            get { return _name; }
            set
            {
                _name = value;
                RaisePropertyChanged(() => Name);
            }
        }

        [Display(AutoGenerateField=false)]
        public ObservableCollection<Note> Notes { get; private set; }        
    }
}