﻿
namespace LargeDataSets.Web
{
    using System.ComponentModel.DataAnnotations;


    // The MetadataTypeAttribute identifies ContactMetadata as the class
    // that carries additional metadata for the Contact class.
    [MetadataTypeAttribute(typeof(ContactMetadata))]
    public partial class Contact
    {

        // This class allows you to attach custom attributes to properties
        // of the Contact class.
        //
        // For example, the following marks the Xyz property as a
        // required property and specifies the format for valid values:
        //    [Required]
        //    [RegularExpression("[A-Z][A-Za-z0-9]*")]
        //    [StringLength(32)]
        //    public string Xyz { get; set; }
        internal sealed class ContactMetadata
        {

            // Metadata classes are not meant to be instantiated.
            private ContactMetadata()
            {
            }

            public string Address { get; set; }

            public string City { get; set; }

            public string Email { get; set; }

            public string FirstName { get; set; }

            public int Id { get; set; }

            public string LastName { get; set; }

            public string State { get; set; }
        }
    }
}
