﻿using System;
using System.Data.Services.Client;
using System.Windows;
using LargeDataSets.ContactReference;

namespace LargeDataSets
{
    public partial class ODataClient
    {
        private readonly DataServiceCollection<Contact> _contacts;
        private readonly ContactsEntities _context;
        private DataServiceQueryContinuation<Contact> _nextPage;

        public ODataClient()
        {
            InitializeComponent(); 
            _context = new ContactsEntities(new Uri("../ContactOData.svc", UriKind.Relative));
            _contacts = new DataServiceCollection<Contact>();
            _contacts.LoadCompleted += ContactsLoadCompleted;
            var query = _context.Contacts.IncludeTotalCount();
            _contacts.LoadAsync(query);
        }

        void ContactsLoadCompleted(object sender, LoadCompletedEventArgs e)
        {
            _nextPage = _contacts.Continuation;

            if (_nextPage == null)
            {
                NextPage.IsEnabled = false;
            }

            TotalCount.Text = e.QueryOperationResponse.TotalCount.ToString();
            Count.Text = _contacts.Count.ToString();
            dgContacts.ItemsSource = _contacts;
            dgContacts.UpdateLayout();            
        }

        void Button_Click(object sender, RoutedEventArgs e)
        {
            _contacts.LoadNextPartialSetAsync();
        }
    }
}
