﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;

namespace LayoutEngine
{
    public partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();
            Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            var masterList = new List<string>();
            for (var x = 0; x < 200; x++)
            {
                var newElement = Guid.NewGuid().ToString();
                masterList.Add(newElement);
            }
            Items.ItemsSource = masterList;
            List.ItemsSource = masterList;
        }

        private void GridPanel_Loaded(object sender, RoutedEventArgs e)
        {
            var grid = sender as Grid;
            if (grid != null)
                foreach(var child in grid.Children)
                {
                    Dump(child, "Rectangle", true);
                }
        }

        private static void Dump(UIElement child, string label, bool grid)
        {
            var element = child as FrameworkElement;
            if (element == null) return;
            var row = grid ? element.GetValue(Grid.RowProperty) : 0;
            var column = grid ? element.GetValue(Grid.ColumnProperty) : 0;
            element.UpdateLayout();
            Debug.WriteLine("{0} {1},{2} = {3} x {4} / {5} x {6}",
                            label,
                            row,
                            column,
                            element.Width,
                            element.Height,
                            element.ActualWidth,
                            element.ActualHeight);
        }

        private void StackPanel_Loaded(object sender, RoutedEventArgs e)
        {
            var stackPanel = sender as StackPanel;
            if (stackPanel == null) return;
            foreach(var child in stackPanel.Children)
            {
                Dump(child, "TextBlock", false);
            }
        }
    }
}
