﻿using System.ComponentModel;

namespace MEFIntro
{
    public class BaseViewModel : INotifyPropertyChanged 
    {
        protected void RaisePropertyChange(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}