﻿using System;
using System.ComponentModel;
using System.ComponentModel.Composition;

namespace MEFIntro
{
    public partial class DetailView 
    {
        [Import]
        public DetailViewModel ViewModel { get; set; }

        public DetailView()
        {
            InitializeComponent();

            if (DesignerProperties.IsInDesignTool)
            {
                DataContext = new {Identifier = Guid.NewGuid().ToString()};
            }
            else
            {
                CompositionInitializer.SatisfyImports(this);
                Loaded += _DetailViewLoaded;
            }            
        }

        void _DetailViewLoaded(object sender, System.Windows.RoutedEventArgs e)
        {
            Loaded -= _DetailViewLoaded;

            if (DataContext != null)
            {
                ViewModel.Identifier = DataContext.ToString();
            }

            DataContext = ViewModel; 
        }        
    }
}
