﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.ComponentModel.Composition;

namespace MEFIntro
{
    [Export]
    public class ViewModel : 
        BaseViewModel, IPartImportsSatisfiedNotification
    {
        [Import]
        public IWelcomeMessageProvider Provider { get; set; }

        private string _welcomeMessage;
        public string WelcomeMessage
        {
            get { return _welcomeMessage; }
            set
            {
                _welcomeMessage = value;
                RaisePropertyChange("WelcomeMessage");
            }
        }

        [ImportMany("Item", AllowRecomposition = true)]
        public ObservableCollection<string> Items { get; set; }
        
        public ViewModel()
        {            
            if (!DesignerProperties.IsInDesignTool) return;

            Items = new ObservableCollection<string>();

            for (var x = 0; x < 100; x++)
            {
                Items.Add(Guid.NewGuid().ToString());
            }           

            WelcomeMessage = "Welcome to the design-time view.";            
        }

        public void OnImportsSatisfied()
        {
            // this code was moved from the constructor
            WelcomeMessage = Provider.GetWelcomeMessage();
        }        
    }
}