﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;

namespace ManualNavigation.Views
{
    public partial class ContentControlNavigation
    {
        private readonly Dictionary<string, UserControl> _controls;

        public ContentControlNavigation()
        {
            _controls = new Dictionary<string, UserControl>
                            {
                                {"Text", ViewHelper.MakeUserControl(ViewHelper.MakeTextBlock())},
                                {"Circle", ViewHelper.MakeUserControl(ViewHelper.MakeEllipse())},
                                {"Square", ViewHelper.MakeUserControl(ViewHelper.MakeSquare())}
                            };
            InitializeComponent();
        }

        private void ButtonClick(object sender, RoutedEventArgs e)
        {
            var button = sender as Button;

            if (button == null)
            {
                return;
            }

            var key = button.Content.ToString();

            if (_controls.ContainsKey(key))
            {
                MainRegion.Content = _controls[key];
            }
        }        
    }
}