﻿using System;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace ManualNavigation.Views
{
    public static class ViewHelper
    {
        public static UserControl MakeUserControl(UIElement child)
        {
            var control = new UserControl
            {
                Name = Guid.NewGuid().ToString(),
                Content = child
            };
            control.Loaded += (o, e) => Debug.WriteLine("{0} {1} loaded.",
                                                        control.Name,
                                                        child.GetType().FullName);
            control.Unloaded += (o, e) => Debug.WriteLine("{0} {1} unloaded.",
                                                          control.Name,
                                                          child.GetType().FullName);
            return control;
        }

        public static Ellipse MakeEllipse()
        {
            return new Ellipse
            {
                Fill = new SolidColorBrush(Colors.Blue),
                Width = 100,
                Height = 100
            };
        }

        public static Rectangle MakeSquare()
        {
            return new Rectangle
            {
                Fill = new SolidColorBrush(Colors.Red),
                Width = 100,
                Height = 100
            };
        }

        public static TextBlock MakeTextBlock()
        {
            return new TextBlock
            {
                FontSize = 70,
                Text = "This is some text."
            };
        }
    }
}