﻿using System;
using System.Windows.Threading;

namespace MemoryLeak
{
    /// <summary>
    /// Dummy class that fires an event every 10 seconds with the time
    /// </summary>
    public static class TimeProvider
    {
        public class TimeProviderEventArgs : EventArgs
        {
            public DateTime Time { get; set; }
        }

        public static event EventHandler<TimeProviderEventArgs> TimeEvent = delegate { };

        private static readonly DispatcherTimer Timer;

        public static void OnTimeEvent(TimeProviderEventArgs e)
        {
            TimeEvent(new object(), e);
        }

        static TimeProvider()
        {
            Timer = new DispatcherTimer {Interval = TimeSpan.FromSeconds(1)};
            Timer.Tick += (timer, eventArgs) => OnTimeEvent(new TimeProviderEventArgs {Time = DateTime.Now});
            Timer.Start();
        }
    }
}