﻿using System;
using System.ComponentModel.Composition;
using System.Windows.Controls;

namespace MetadataExample
{
    [MetadataAttribute]
    [AttributeUsage(AttributeTargets.Class | AttributeTargets.Property, 
        AllowMultiple = false)]
    public class ExportAsShapeAttribute : ExportAttribute, IControlTypeMetadata
    {
        public ControlTypes ControlType { get; private set; }
        
        public ExportAsShapeAttribute(ControlTypes controlType)
            : base(typeof(UserControl))
        {
            ControlType = controlType;
        }
    }
}