﻿using System;
using System.Runtime.InteropServices;

namespace PInvoke
{
    public class SoundPlayer : ISoundPlayer
    {
        public void PlaySound(BeepTypes type)
        {
            if (!MessageBeep((UInt32) type))
            {
                throw new Exception("Beep failed!");
            }
        }

        [DllImport("User32.dll", ExactSpelling = true)]
        private static extern Boolean MessageBeep(UInt32 beepType);        
    }

    public enum BeepTypes : uint
    {
        Ok = 0x00000000,
        Error = 0x00000010,
        Warning = 0x00000030,
        Information = 0x00000040
    }

    public static class BeepTypeExtensions
    {
        public static BeepTypes AsBeepTypeEnum(this string beepType)
        {
            BeepTypes beepTypeEnum;
            return Enum.TryParse(beepType, true, out beepTypeEnum)
                        ? beepTypeEnum
                        : BeepTypes.Error;
        }
    }
}