﻿using System;
using System.Linq;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Animation;

namespace StoryboardExamples
{
    public partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();            
        }

        private void LayoutRoot_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var colorAnimation in Resources.Values.OfType<Storyboard>()
                .SelectMany(sb => sb.Children.OfType<ColorAnimation>()))
            {
                colorAnimation.Duration = TimeSpan.FromSeconds(2);
                colorAnimation.From = Colors.Blue;
                colorAnimation.To = Colors.Orange;
            }
        }

        private void btnStart_Click(object sender, RoutedEventArgs e)
        {
            btnStart.IsEnabled = false;
            btnStop.IsEnabled = true;
            foreach (var sb in Resources.Values.OfType<Storyboard>())
            {                
                sb.Begin();
            }
        }

        private void btnStop_Click(object sender, RoutedEventArgs e)
        {
            btnStart.IsEnabled = true;
            btnStop.IsEnabled = false;
            foreach (var sb in Resources.Values.OfType<Storyboard>())
            {
                sb.Stop();
            }
        }
    }
}
