﻿using System;
using System.Diagnostics;
using System.Threading;
using System.Windows.Automation;
using System.Windows.Forms;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace ToDoList.CLRTests
{
    [TestClass]
    public class QuickAddControlUITests
    {
        [TestMethod]
        public void TestDateValidation()
        {
            var proc =
                new Process
                    {
                        EnableRaisingEvents = false,
                        StartInfo =
                            {
                                FileName =
                                    "http://localhost:6829/ToDoListTestPage.aspx"
                            }
                    };
            proc.Start();
            Thread.Sleep(3000);

            var processes = Process.GetProcessesByName("iexplore");

            var ranTest = false;

            foreach (var process in processes)
            {
                try
                {
                    var browser = AutomationElement
                        .FromHandle(process.MainWindowHandle);
                    var treeWalker =
                        new TreeWalker(new PropertyCondition(
                                            AutomationElement.AutomationIdProperty,
                                            "DueDate"));
                    var dateBox = treeWalker.GetFirstChild(browser);
                    dateBox.SetFocus();
                    for (var x = 0; x < 20; x++)
                    {
                        SendKeys.SendWait("{DEL}");
                    }
                    Thread.Sleep(500);
                    SendKeys.SendWait("1/1/2000");
                    treeWalker =
                        new TreeWalker(
                            new PropertyCondition(
                                AutomationElement.AutomationIdProperty, "Title"));
                    var titleBox = treeWalker.GetNextSibling(dateBox);
                    titleBox.SetFocus();
                    SendKeys.SendWait("Valid title");
                    treeWalker = new TreeWalker(
                        new PropertyCondition(
                            AutomationElement.ClassNameProperty, "Button"));

                    var button = treeWalker.GetFirstChild(browser);
                    Assert.IsFalse(button.Current.IsEnabled, "Button should be disabled with invalid date.");

                    dateBox.SetFocus();
                    for (var x = 0; x < 20; x++)
                    {
                        SendKeys.SendWait("{DEL}");
                    }
                    SendKeys.SendWait("1/1/2099");
                    titleBox.SetFocus();
                    Assert.IsTrue(button.Current.IsEnabled, "Button should be enabled with valid date.");
                    process.Kill();
                    ranTest = true;
                    break;
                }
                catch
                {
                    process.Kill();
                    continue;
                }
            }

            Assert.IsTrue(ranTest, "Unable to run automation test.");
        }
    }
}