﻿using System;

namespace ToDoList.Contracts
{
    public interface IToDoItem
    {
        Guid Id { get; set; }
        string Title { get; set; }
        string Description { get; set; }
        DateTime DueDate { get; set; }
        DateTime CompletedDate { get; }
        bool IsComplete { get; }
        Uri Link { get; set; }
        bool IsPastDue { get; }
        bool IsDueTomorrow { get; }
        bool IsDueNextWeek { get; }
        bool IsInFuture { get; }
        bool ValidateDueDate(DateTime dueDate, out string error);
        bool ValidateTitle(string title, out string error);
        void MarkComplete();
        void CreateNew();
    }
}