﻿using System;
using System.ComponentModel.Composition;
using System.Linq;
using System.Runtime.Serialization;
using System.Security.Permissions;
using System.ServiceModel;
using System.ServiceModel.Activation;
using ToDoList.Contracts;
using ToDoList.Model;

namespace ToDoList.Web
{
    [ServiceContract(Namespace = "http://jeremylikness.com/examples")]
    [SilverlightFaultBehavior]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class ToDoListService
    {
        [Import]
        private IRepository Repository { get; set; }


        // uncomment this line for the invoke to succeed (provided you have defined the role)
        //[PrincipalPermissionAttribute(SecurityAction.Demand, Role = "ToDoListUser")]
        // if this line is uncommented you will receive a security exception (provided the role doesn't exist)
        [PrincipalPermissionAttribute(SecurityAction.Demand, Role="FakeRole")]
        [OperationContract]
        public void Delete(Guid id)
        {
            if (Repository == null)
            {
                MEFBootstrapper.SatisfyImports(this);
            }
            
            Repository.Delete(new ToDoItem { Id = id });
        }

        // Add more operations here and mark them with [OperationContract]
    }
}
