﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Security.Permissions;
using System.Security.Principal;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Threading;
using ToDoList.Contracts;
using ToDoList.Model;

namespace ToDoList.Web
{
    
    [ServiceContract(Namespace = "http://jeremylikness.com/examples")]
    [SilverlightFaultBehavior]
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class ToDoListService
    {
        [Import]
        private IRepository Repository { get; set; }

        [PrincipalPermissionAttribute(SecurityAction.Demand, Role="ToDoListUser")]
        [OperationContract]
        public void Delete(Guid id)
        {
            if (Repository == null)
            {
                MEFBootstrapper.SatisfyImports(this);
            }

            Repository.Delete(new ToDoItem {Id = id});
        }        

        // Add more operations here and mark them with [OperationContract]
    }
}
