﻿
using System.ComponentModel.Composition;
using ToDoList.Contracts;
using System.Linq;
using System.ServiceModel.DomainServices.Hosting;
using System.ServiceModel.DomainServices.Server;
using System;

namespace ToDoList.Web
{    
    [EnableClientAccess]
    public class ToDoRiaService : DomainService
    {
        [Import]
        public IRepository Repository { get; set; }

        public ToDoRiaService()
        {
            MEFBootstrapper.SatisfyImports(this);
        }

        [Query]
        public IQueryable<ToDoItemRia> GetTasks()
        {
            return Repository.Query().Select(item => new ToDoItemRia(item)).AsQueryable();            
        }

        [Insert]
        public void InsertTask(ToDoItemRia item)
        {
            Repository.Save(item);            
        }

        [Update]
        public void UpdateTask(ToDoItemRia item)
        {
            Repository.Save(item);
        }

        [Delete]
        public void DeleteTask(ToDoItemRia item)
        {
            Repository.Delete(item);
        }        
    }
}


