﻿using System;
using ToDoList.Model;

namespace ToDoList.Filters
{
    public class FilterBase
    {
        private FilterBase(string name, Predicate<ToDoItem> filter)
        {
            Name = name;
            Filter = filter;
        }

        public static FilterBase Create(string name, Predicate<ToDoItem> filter)
        {
            return new FilterBase(name, filter);
        }
        
        public string Name { get; private set; }
        public Predicate<ToDoItem> Filter { get; private set; }

        public override bool Equals(object obj)
        {
            return obj is FilterBase && ((FilterBase) obj).Name.Equals(Name);
        }

        public override int GetHashCode()
        {
            return Name.GetHashCode();
        }
    }
}