﻿using System.ComponentModel.Composition;
using Jounce.Core.View;
using Jounce.Core.ViewModel;
using ToDoList.Behaviors;
using ToDoList.Contracts;
using ToDoList.ViewModels;

namespace ToDoList
{
    [ExportAsView(typeof(MainPage), IsShell = true)]
    public partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();
            Loaded += MainPageLoaded;
        }

        void MainPageLoaded(object sender, System.Windows.RoutedEventArgs e)
        {
            Loaded -= MainPageLoaded;
            EditContainer.Content = null;
            OverlayHelper.Overlay = OverlayRectangle;
            OverlayHelper.Hide();
        }

        [Import]
        public IRepository Repository { get; set; }

        [Export]
        public ViewModelRoute Binding
        {
            get { return ViewModelRoute.Create<MainViewModel, MainPage>(); }
        }
    }
}
