﻿using System.ComponentModel.Composition;
using Jounce.Core.ViewModel;
using Jounce.Framework;
using ToDoList.Contracts;

namespace ToDoList.ViewModels
{
    [ExportAsViewModel(typeof(MainViewModel))]
    public class MainViewModel : BaseViewModel 
    {
        [Import]
        public Global Globals { get; set; }

        [Import]
        public IToDoListApplicationContext AppContext { get; set; }        
        
        protected override void InitializeVm()
        {
            EventAggregator.Publish(Globals.QuickAddView.AsViewNavigationArgs());
            EventAggregator.Publish(Globals.FilterView.AsViewNavigationArgs());
            EventAggregator.Publish(Globals.ToDoListView.AsViewNavigationArgs());            
            base.InitializeVm();
            AppContext.Title = "To-Do List: Designing Silverlight Business Applications";
        }     
    }
}