﻿using System.ComponentModel.Composition;
using System.Windows.Input;
using Jounce.Core.ViewModel;
using Jounce.Framework.Command;
using Microsoft.Expression.Interactivity.Core;
using ToDoList.Contracts;

namespace ToDoList.ViewModels
{
    [ExportAsViewModel(typeof(ToDoListItemViewModel))]
    public class ToDoListItemViewModel : BaseViewModel, IToDoListItemViewModel
    {
        [Import]
        public IRepository Repository { get; set; }

        public ToDoListItemViewModel()
        {
            DeleteCommand = new ActionCommand<object>(
                obj=>Repository.Delete(_task));
        }

        private IToDoItem _task;

        public IToDoItem Task
        {
            get { return _task; }
            set 
            { 
                _task = value;
                RaisePropertyChanged(() => Task);
            }
        }

        public ICommand DeleteCommand { get; private set; }
    }
}