﻿using System.ComponentModel.Composition;
using System.Windows;
using System.Windows.Controls;
using Jounce.Core.Event;
using Jounce.Core.View;
using Jounce.Framework;
using Jounce.Regions.Core;

namespace ToDoList.Views
{

    [ExportAsView(typeof(AdminView))]
    [ExportViewToRegion(typeof(AdminView), "MainRegion")]
    public partial class AdminView
    {
        [Import]
        public IEventAggregator EventAggregator { get; set; }

        [Import]
        public Global Globals { get; set; }

        public AdminView()
        {
            InitializeComponent();            
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            if (TaskSource.DomainContext.HasChanges)
            {

                ((Button)sender).IsEnabled = false;
                TaskSource.DomainContext.SubmitChanges(
                    result =>
                    {
                        ((Button)sender).IsEnabled = true;
                        EventAggregator.Publish(Globals.ToDoListView.AsViewNavigationArgs());
                    }, null);
            }
            else
            {
                EventAggregator.Publish(Globals.ToDoListView.AsViewNavigationArgs());
            }
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            EventAggregator.Publish(Globals.ToDoListView.AsViewNavigationArgs());
        }       
        
    }
}
