﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;

namespace ViewModelLocators
{
    public class Binder
    {
        private readonly Dictionary<Type, Type> _bindings =
            new Dictionary<Type, Type>
                {
                    { typeof(DesignControl), typeof(ViewModel) }
                };

        public void Bind(Control control)
        {
            if (!_bindings.ContainsKey(control.GetType()))
            {
                return;
            }

            var vm = Activator
                .CreateInstance(
                    _bindings[control.GetType()]);

            ((ViewModel) vm).GoToVisualState =
                state => VisualStateManager
                                .GoToState(control, state, true);

            control.DataContext = vm;
        }
    }
}