﻿using System.ComponentModel;
using System.Windows;
using System.Windows.Controls;

namespace ViewModelLocators
{
    public class Controller
    {
        private readonly IViewModelInterface _vm;

        public Controller(Control control)
        {
            if (DesignerProperties.IsInDesignTool)
            {
                _vm = new DesignViewModel();
            }
            else
            {
                _vm = new ViewModel
                            {
                                GoToVisualState =
                                    state => VisualStateManager.GoToState(
                                        control, state, true)
                            };
                VisualStateManager.GoToState(
                    control, "Circle", false);
            }
            control.DataContext = _vm;
        }
    }
}