﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace ViewModelLocators
{
    public class ViewModel : IViewModelInterface, INotifyPropertyChanged
    {
        public ViewModel()
        {
            GoToVisualState = state => { };
        }
        
        private readonly List<string> _shapes
            = new List<string>
                    {
                        "Circle",
                        "Square",
                        "Rectangle"
                    };

        public List<string> Shapes
        {
            get { return _shapes; }
        }

        public Action<string> GoToVisualState { get; set; }
        
        private string _selectedShape;
        public string SelectedShape
        {
            get { return _selectedShape; }
            set
            {
                _selectedShape = value;
                var handler = PropertyChanged;
                
                if (handler != null)
                {
                    handler(this, new PropertyChangedEventArgs("SelectedShape"));
                }

                if (!string.IsNullOrEmpty(value))
                {
                    GoToVisualState(value);
                }

            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }
}