﻿using System.Windows;
using System.Windows.Input;
using Vsm = System.Windows.VisualStateManager;

namespace VisualStateManager
{
    public partial class MainPage
    {
        private bool _on;

        public MainPage()
        {
            InitializeComponent();
            Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            Loaded -= MainPage_Loaded;
            Vsm.GoToState(this, "SwitchOn", false);
            _on = true;
        }

        private void _On()
        {
            Vsm.GoToState(this, "SwitchOn", true);
            _on = true;
        }

        private void _Off()
        {
            Vsm.GoToState(this, "SwitchOff", true);
            _on = false;
        }

        private void SwitchLever_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            if (_on) _Off();
            else _On();
        }

        
        private void SwitchOnLight_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            _On();
        }

        private void SwitchOffLight_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            _Off();
        }
    }
}
