﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Interactivity;
using System.Windows.Media;

namespace VsmAggregator
{
    public class VisualStateSubscriptionBehavior : Behavior<FrameworkElement>
    {        
        public string EventName { get; set; }

        public string StateName { get; set; }

        public bool UseTransitions { get; set; }

        protected override void OnAttached()
        {
            AssociatedObject.Loaded += AssociatedObject_Loaded;
        }

        void AssociatedObject_Loaded(object sender, RoutedEventArgs e)
        {
            Control control = null;

            if (AssociatedObject is Control)
            {
                control = AssociatedObject as Control;
            }
            else
            {
                var parent = VisualTreeHelper.GetParent(AssociatedObject);
               
                while (!(parent is Control) && parent != null)
                {
                    parent = VisualTreeHelper.GetParent(parent);
                }

                if (parent != null)
                {
                    control = parent as Control;
                }
            }

            if (control != null)
            {
                ((App)App.Current).VsmAggregator
                    .AddSubscription(control, EventName, StateName, UseTransitions);
            }
        }
    }

}